// JavaScript Document
var ctbtnOffsetX = -16;
var ctbtnOffsetY = -16;
var cursorX = 0;
var cursorY = 0;
var cursorStep = 2.0;
var ctbtnStep = 2.0;

var mouseX = 0;
var mouseY = 0;

var tempX = 0;
var tempY = 0;
var ctbtnX = 0;
var ctbtnY = 0;
var ctbtnActive = false;

var IE = document.all?true:false
if (!IE) document.captureEvents(Event.MOUSEMOVE)
document.onmousemove = getMouseXY;
document.onkeydown = KeyCheck;
document.onkeyup = KeyOut;

function DegToRad(angle){
  return (angle/(2 * Math.PI)) * 360;
}

function RadToDeg(angle){
  return angle * (180/Math.PI);
}

function getMouseXY(e) {
	if (IE) { // grab the x-y pos.s if browser is IE
		mouseX = event.clientX + document.body.scrollLeft;
		mouseY = event.clientY + document.body.scrollTop;
	} else {  // grab the x-y pos.s if browser is NS
		mouseX = e.pageX;
		mouseY = e.pageY;
	}  
	// catch possible negative values in NS4
	if (mouseX < 0){mouseX = 0}
	if (mouseY < 0){mouseY = 0}  

		//Calc new position
		var x = ctbtnX + (mouseX - tempX);
		var y = ctbtnY + (mouseY - tempY);
    //Convert
  	x = (x - ctbtnOffsetX) - 81;
  	y = (y - ctbtnOffsetY) - 81;
		//Check borders
	  var c = Math.sqrt(x*x + y*y);
	  if(y < 0)
	     var a = +(Math.asin(x/c)+(Math.PI / 2) + Math.PI);
	  else
	     var a = -(Math.asin(x/c)+(Math.PI / 2) + Math.PI);
		var xMax = 81 * Math.cos(a);
    var yMax = 81 * Math.sin(a);
		document.getElementById('dbtn').style.left = (xMax - 1 + 81)+'px';
		document.getElementById('dbtn').style.top = (yMax - 1 + 81)+'px';	

	if(ctbtnActive){
		//Limit
		if(Math.abs(x) > Math.abs(xMax)) x = xMax;
		if(Math.abs(y) > Math.abs(yMax)) y = yMax;
    //Convert                    
  	x = (x + ctbtnOffsetX) + 81;
  	y = (y + ctbtnOffsetY) + 81;
		//Set new position
		document.getElementById('ctbtn').style.left = (x)+'px';
		document.getElementById('ctbtn').style.top = (y)+'px';	
	}
	return true;
}

function KeyCheck(e) {
		ctbtnX = parseFloat(document.getElementById('ctbtn').style.left.replace("px",""));
		ctbtnY = parseFloat(document.getElementById('ctbtn').style.top.replace("px",""));
		
		var x = ctbtnX;
    var y = ctbtnY;
    
    ctbtnActive = true;
		
    var KeyID = (window.event) ? event.keyCode : e.keyCode;
		//Calc new position
		if(KeyID == 38) y = y - 2;
    if(KeyID == 40) y = y + 2;
    if(KeyID == 37) x = x - 2;
    if(KeyID == 39) x = x + 2;

    //Convert
  	x = (x - ctbtnOffsetX) - 81;
  	y = (y - ctbtnOffsetY) - 81;
		//Check borders
	  var c = Math.sqrt(x*x + y*y);
	  if(y < 0)
	     var a = +(Math.asin(x/c)+(Math.PI / 2) + Math.PI);
	  else
	     var a = -(Math.asin(x/c)+(Math.PI / 2) + Math.PI);
		var xMax = 81 * Math.cos(a);
    var yMax = 81 * Math.sin(a);
		document.getElementById('dbtn').style.left = (xMax - 1 + 81)+'px';
		document.getElementById('dbtn').style.top = (yMax - 1 + 81)+'px';	
		
		//Override keys
		document.getElementById('console-title').innerHTML = KeyID;
    //Forward
    if(KeyID == 87){
      x = 0; cursorX = 0;
      y = -81; cursorY = -81;
    }       
    //Backward
    if(KeyID == 83){
      x = 0; cursorX = 0;
      y = 81; cursorY = 81;
    }
    //Left
    if(KeyID == 65){
      x = -57;  cursorX = -57;
      y = -57;  cursorY = -57;
    }
    //Right
    if(KeyID == 68){
      x = 57;  cursorX = 57;
      y = -57; cursorY = -57;
    }
    //Turn left
    if(KeyID == 81){
      x = -81;  cursorX = -81;
      y = -1;   cursorY = -1;
    }
    //Turn right
    if(KeyID == 69){
      x = 81;   cursorX = 81;
      y = -1;   cursorY = -1;
    }
    if(KeyID == 88){
      x = 0;    cursorX = 0;
      y = 0;    cursorY = 0;
    }
    
		//Limit
		if(Math.abs(x) > Math.abs(xMax)) x = xMax;
		if(Math.abs(y) > Math.abs(yMax)) y = yMax;
    //Convert                    
  	x = (x + ctbtnOffsetX) + 81;
  	y = (y + ctbtnOffsetY) + 81;
		//Set new position
		document.getElementById('ctbtn').style.left = (x)+'px';
		document.getElementById('ctbtn').style.top = (y)+'px';	
	return true;
}

function KeyOut(e){
  ctbtnActive = false;
}

function ctbtnDown(){
	if(!ctbtnActive){
		//Get mouse position
		tempX = mouseX;
		tempY = mouseY;
		ctbtnX = parseFloat(document.getElementById('ctbtn').style.left.replace("px",""));
		ctbtnY = parseFloat(document.getElementById('ctbtn').style.top.replace("px",""));
		ctbtnActive = true;
	}
}

function ctbtnUp(){
	ctbtnActive = false;	
}

function CalculateCursor(){
	//Get ctbtn position
	var x = parseFloat(document.getElementById('ctbtn').style.left.replace("px",""));
	var y = parseFloat(document.getElementById('ctbtn').style.top.replace("px",""));
	//Correct to cursor position
	x = (x - ctbtnOffsetX) - 81;
	y = (y - ctbtnOffsetY) - 81;
	//Calculate vector
	var vectorX = x - cursorX;
	var vectorY = y - cursorY;
	//Scale vector
	if(Math.abs(vectorX) > Math.abs(vectorY)){
		vectorY = vectorY / Math.abs(vectorX);
		vectorX = vectorX / Math.abs(vectorX);
	} else if(Math.abs(vectorX) < Math.abs(vectorY)) {
		vectorX = vectorX / Math.abs(vectorY);
		vectorY = vectorY / Math.abs(vectorY);
	} else {
		vectorX = 0;
		vectorY = 0;
	}
	//Move cursor to position
	cursorX = Math.floor(cursorX + (vectorX * cursorStep));
	cursorY = Math.floor(cursorY + (vectorY * cursorStep));
	//Move cursor icon
	document.getElementById('ctcursor').style.left = (cursorX + 81 - 1)+'px';
	document.getElementById('ctcursor').style.top = (cursorY + 81 - 1)+'px';
}

function ReturnCtbtn(){
	//Get ctbtn position
	var x = parseFloat(document.getElementById('ctbtn').style.left.replace("px",""));
	var y = parseFloat(document.getElementById('ctbtn').style.top.replace("px",""));
	//Correct to cursor position
	x = (x - ctbtnOffsetX) - 81;
	y = (y - ctbtnOffsetY) - 81;
	//Get back ctbtn if not active
	if(!ctbtnActive){
		//Calculate vector
		var vectorX = 0-x;
		var vectorY = 0-y;
		//Scale vector
		if(Math.abs(vectorX) > Math.abs(vectorY)){
			vectorY = vectorY / Math.abs(vectorX);
			vectorX = vectorX / Math.abs(vectorX);
		} else if(Math.abs(vectorX) < Math.abs(vectorY)) {
			vectorX = vectorX / Math.abs(vectorY);
			vectorY = vectorY / Math.abs(vectorY);
		} else {
			vectorX = 0;
			vectorY = 0;
		}
		var newX = Math.floor(x + (vectorX * ctbtnStep));
		var newY = Math.floor(y + (vectorY * ctbtnStep));
		//Move cursor icon
		if(newX != 0 || newX != 1 || newY != 0 || newY != 1){
			document.getElementById('ctbtn').style.left = (newX + 81 + ctbtnOffsetX)+'px';
			document.getElementById('ctbtn').style.top = (newY + 81 + ctbtnOffsetY)+'px';
		}
	}	
}

function UpdateEngines(){
	  var c = Math.sqrt(cursorX*cursorX + cursorY*cursorY);
    var a = (Math.asin(cursorX/c));
    
    var ratio = RadToDeg(Math.abs(a))/90;
    var mp = 1.0 - (ratio*2.0);
    var speed = c / 81;
    if(speed < 0.1) speed = 0;
    
    //Select engine
    if(cursorX < 0){
      var left = mp;
      var right = 1;
    } else if(cursorX > 0){
      var left = 1;
      var right = mp;
    } else {
      var left = 1;
      var right = 1;    
    }
    //Set direction
    if(cursorY > 0){
      left = -left;
      right = -right;
    }
    
    var engineA = Math.floor((left*speed) * 63);
    var engineB = Math.floor((right*speed) * 63);

    //document.getElementById('console-title').innerHTML = engineA+":"+engineB;
    if(speed == 0)
      RCDC_Stop();
    else
      RCDC_Update(engineB, engineA);
}

function InitController(){
	setInterval("CalculateCursor();", 200);
	setInterval("UpdateEngines();", 200);
	setInterval("ReturnCtbtn();", 50);
}

FormInits["controller"] = 'InitController();';